## ros-melodic-pid 0.0.27

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(pid)

add_compile_options(-std=c++11)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  roscpp
  std_msgs
  message_generation
  dynamic_reconfigure
)

generate_dynamic_reconfigure_options(
    cfg/Pid.cfg
)
## System dependencies are found with CMake's conventions
# find_package(Boost REQUIRED COMPONENTS system)


## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need

#generate_messages(
#  DEPENDENCIES
#  std_msgs
#)

catkin_package(
  INCLUDE_DIRS include
#  LIBRARIES pid
   CATKIN_DEPENDS roscpp std_msgs message_runtime dynamic_reconfigure
#  DEPENDS system_lib
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(include
  ${catkin_INCLUDE_DIRS}
  ${dynamic_reconfigure_PACKAGE_PATH}/cmake/cfgbuild.cmake
)

## Declare a cpp library
# add_library(pid
#   src/${PROJECT_NAME}/pid.cpp
# )

## Declare a cpp executable

add_executable(controller src/controller.cpp src/pid.cpp)
add_executable(plant_sim src/plant_sim.cpp)
add_executable(setpoint_node src/setpoint_node.cpp)
add_executable(sim_time src/sim_time.cpp)
add_executable(autotune src/autotune.cpp)

add_dependencies(controller ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
add_dependencies(plant_sim ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
add_dependencies(setpoint_node ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
add_dependencies(sim_time ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
add_dependencies(autotune ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes

target_link_libraries(controller ${catkin_LIBRARIES})
target_link_libraries(plant_sim ${catkin_LIBRARIES})
target_link_libraries(setpoint_node ${catkin_LIBRARIES})
target_link_libraries(sim_time ${catkin_LIBRARIES})
target_link_libraries(autotune ${catkin_LIBRARIES})

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
install(TARGETS controller plant_sim setpoint_node sim_time autotune
#  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
# catkin_add_gtest(${PROJECT_NAME}-test test/test_pid.cpp)
# if(TARGET ${PROJECT_NAME}-test)
#   target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})
# endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== debian/changelog ===
ros-melodic-pid (0.0.27-0stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Andy Zelenak <andyz@utexas.edu>  Sun, 15 Jul 2018 02:10:57 -0000

ros-melodic-pid (0.0.15-0stretch) stretch; urgency=high

  * Fixing header "include" error, possible dynamic_reconfigure errors.
  * Contributors: Andy Zelenak

 -- Andy Zelenak <andyz@utexas.edu>  Mon, 22 Feb 2016 06:00:00 -0000

ros-melodic-pid (0.0.10-0stretch) stretch; urgency=high

  * Add diagnostics running at 4Hz. Publish interesting data like setpoint, plant state,
  error, control effort in diags for viewing
  * Add ROS private parameters to set Pid params and simulator param
  * Add Auto/Manual mode: Listen to the /pid_enable topic for a std_msgs/Bool
  that will disable or re-enable output from the PID controller
  * Support reverse_acting parameter, for plants where the control input acts
  in the opposite direction to the plant-state. E.g. Differential-drive robots
  often have one direct and one reverse-acting PID
  * Support faster-than-wallclock simulation via a /clock publisher and the
  /use_sim_time parameter
  * Add launch files for first & 2nd order behaviors. Get them to launch plots,
  diag monitor, reconfigure gui
  * Split setpoint generator out into a separate node
  * Rename simulator to plant_sim.cpp & give it 1st & 2nd order behaviors, configured
  with a parameter.
  * Delete first_order_plant_sim.cpp, which is subsumed into plant_sim.cpp. Remove
  plant header, which was almost content-free.
  * Remove msg directory & switch to using Float64 messages for setpoint,
  process state, & control effort. Now it's generic - no special messages needed.
  * Explicitly call out std namespace to avoid accidental name conflicts
  * Remove parameter length checks to allow parameters to be set in part from
  launch file (the usual way), and in part from cmd line args (an infrequently-used
  way)
  * Rename pid_header.h to controller.h because it's used by controller.cpp - more standard
  C++ naming style
  * Add copyrights
  * Contributors: AndyZe, Paul Bouchier

 -- Andy Zelenak <andyz@utexas.edu>  Mon, 25 Jan 2016 06:00:00 -0000

ros-melodic-pid (0.0.9-0stretch) stretch; urgency=high

  * Merged in bouchier/pid (pull request #1)
    Add dynamic reconfigure for Kx, change plant setpoint
  * add dynamic reconfigure for Kx, change plant setpoint
  * Contributors: AndyZe, Paul Bouchier

 -- Andy Zelenak <andyz@utexas.edu>  Sun, 27 Dec 2015 06:00:00 -0000

ros-melodic-pid (0.0.7-0stretch) stretch; urgency=high

  * Added a launch file, which required the arguments to be processed differently.
  * Contributors: Andy Zelenak

 -- Andy Zelenak <andyz@utexas.edu>  Sun, 26 Jul 2015 05:00:00 -0000

ros-melodic-pid (0.0.6-0stretch) stretch; urgency=high

  * Changing the way parameters are passed to check_user_input().
  * Contributors: Andy Zelenak

 -- Andy Zelenak <andyz@utexas.edu>  Tue, 09 Jun 2015 05:00:00 -0000

ros-melodic-pid (0.0.5-0stretch) stretch; urgency=high

  * Adding an anti-windup option.
  * Contributors: Andy Zelenak

 -- Andy Zelenak <andyz@utexas.edu>  Tue, 09 Jun 2015 05:00:00 -0000

ros-melodic-pid (0.0.3-0stretch) stretch; urgency=high



 -- Andy Zelenak <andyz@utexas.edu>  Sat, 14 Mar 2015 05:00:00 -0000

ros-melodic-pid (0.0.2-0stretch) stretch; urgency=high



 -- Andy Zelenak <andyz@utexas.edu>  Fri, 13 Mar 2015 05:00:00 -0000

ros-melodic-pid (0.0.1-0stretch) stretch; urgency=high

  * Fixing various minor bugs related to user input.
  * Pre-release commit.
  * It WORKS!
  * It's talking with the plant sim now. Just the PID programming remains.
  * Making progress with the command line input.
  * Rough outline of the program. Need to take inputs on the command line next.
  * Initial commit
  * Contributors: Andy Zelenak

 -- Andy Zelenak <andyz@utexas.edu>  Sun, 08 Mar 2015 06:00:00 -0000

=== debian/control ===
Source: ros-melodic-pid
Section: misc
Priority: extra
Maintainer: Andy Zelenak <andyz@utexas.edu>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-dynamic-reconfigure, ros-melodic-message-generation, ros-melodic-roscpp, ros-melodic-std-msgs
Homepage: http://wiki.ros.org/pid
Standards-Version: 3.9.2

Package: ros-melodic-pid
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-dynamic-reconfigure, ros-melodic-message-runtime, ros-melodic-roscpp, ros-melodic-std-msgs
Description: Launch a PID control node.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-pid//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
